use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum TableColumnEnumAggregation {
    First(super::NoConfigAggregation),
    Last(super::NoConfigAggregation),
    AllDistinct(super::NoConfigAggregation),
    CountDistinct(super::NoConfigAggregation),
    ValueCounts(super::NoConfigAggregation),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for TableColumnEnumAggregation {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            TableColumnEnumAggregation::First(value) => {
                map.serialize_entry(&"type", &"first")?;
                map.serialize_entry(&"first", value)?;
            }
            TableColumnEnumAggregation::Last(value) => {
                map.serialize_entry(&"type", &"last")?;
                map.serialize_entry(&"last", value)?;
            }
            TableColumnEnumAggregation::AllDistinct(value) => {
                map.serialize_entry(&"type", &"allDistinct")?;
                map.serialize_entry(&"allDistinct", value)?;
            }
            TableColumnEnumAggregation::CountDistinct(value) => {
                map.serialize_entry(&"type", &"countDistinct")?;
                map.serialize_entry(&"countDistinct", value)?;
            }
            TableColumnEnumAggregation::ValueCounts(value) => {
                map.serialize_entry(&"type", &"valueCounts")?;
                map.serialize_entry(&"valueCounts", value)?;
            }
            TableColumnEnumAggregation::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for TableColumnEnumAggregation {
    fn deserialize<D>(d: D) -> Result<TableColumnEnumAggregation, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = TableColumnEnumAggregation;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union TableColumnEnumAggregation")
    }
    fn visit_map<A>(self, mut map: A) -> Result<TableColumnEnumAggregation, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::First, Some(Variant_::First)) => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::First(value)
                    }
                    (Variant_::Last, Some(Variant_::Last)) => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::Last(value)
                    }
                    (Variant_::AllDistinct, Some(Variant_::AllDistinct)) => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::AllDistinct(value)
                    }
                    (Variant_::CountDistinct, Some(Variant_::CountDistinct)) => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::CountDistinct(value)
                    }
                    (Variant_::ValueCounts, Some(Variant_::ValueCounts)) => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::ValueCounts(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            TableColumnEnumAggregation::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::First => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::First(value)
                    }
                    Variant_::Last => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::Last(value)
                    }
                    Variant_::AllDistinct => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::AllDistinct(value)
                    }
                    Variant_::CountDistinct => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::CountDistinct(value)
                    }
                    Variant_::ValueCounts => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::ValueCounts(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        TableColumnEnumAggregation::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    First,
    Last,
    AllDistinct,
    CountDistinct,
    ValueCounts,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::First => "first",
            Variant_::Last => "last",
            Variant_::AllDistinct => "allDistinct",
            Variant_::CountDistinct => "countDistinct",
            Variant_::ValueCounts => "valueCounts",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "first" => Variant_::First,
            "last" => Variant_::Last,
            "allDistinct" => Variant_::AllDistinct,
            "countDistinct" => Variant_::CountDistinct,
            "valueCounts" => Variant_::ValueCounts,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the TableColumnEnumAggregation union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
